"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var helpers_1 = require("../helpers/helpers");
var GroupByPipe = (function () {
    function GroupByPipe() {
    }
    GroupByPipe.prototype.transform = function (input, discriminator, delimiter) {
        if (discriminator === void 0) { discriminator = []; }
        if (delimiter === void 0) { delimiter = '|'; }
        if (!Array.isArray(input)) {
            return input;
        }
        return this.groupBy(input, discriminator, delimiter);
    };
    GroupByPipe.prototype.groupBy = function (list, discriminator, delimiter) {
        var _this = this;
        return list.reduce(function (acc, payload) {
            var key = _this.extractKeyByDiscriminator(discriminator, payload, delimiter);
            acc[key] = Array.isArray(acc[key])
                ? acc[key].concat([payload])
                : [payload];
            return acc;
        }, {});
    };
    GroupByPipe.prototype.extractKeyByDiscriminator = function (discriminator, payload, delimiter) {
        if (helpers_1.isFunction(discriminator)) {
            return discriminator(payload);
        }
        if (Array.isArray(discriminator)) {
            return discriminator.map(function (k) { return helpers_1.extractDeepPropertyByMapKey(payload, k); }).join(delimiter);
        }
        return helpers_1.extractDeepPropertyByMapKey(payload, discriminator);
    };
    return GroupByPipe;
}());
GroupByPipe.decorators = [
    { type: core_1.Pipe, args: [{ name: 'groupBy' },] },
];
/** @nocollapse */
GroupByPipe.ctorParameters = function () { return []; };
exports.GroupByPipe = GroupByPipe;
//# sourceMappingURL=group-by.js.map